#!/usr/bin/lua


function gen_vhdl_ramcode(ram)
  local prefix = string.lower(periph.hdl_prefix.."_"..ram.hdl_prefix);

-- generate the RAM-related ports
  ram.ports = { port (SLV, ram.addr_bits - ram.wrap_bits, "in", prefix.."_addr_i", "Ports for RAM: "..ram.name ) };

  if(match(ram.access_dev, {READ_ONLY, READ_WRITE})) then
		table_join(ram.ports, {	port(SLV, ram.width, "out", prefix.."_data_o") });
  end

  if(match(ram.access_dev, {WRITE_ONLY, READ_WRITE})) then
		table_join(ram.ports, { port(SLV, ram.width, "in", prefix.."_data_i"), 
														port(BIT, 0, "in", prefix.."_we_i") });
  end

	local raminst = vhdl_new_instance();

	

end

function gen_vhdl_rams()
	foreach_reg(function(reg) if(reg.__type == TYPE_RAM) then gen_vhdl_ramcode(reg); end end);
end